﻿package {
	
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.media.Sound;
	import flash.media.SoundMixer;
	import flash.media.SoundChannel;
	import flash.net.URLRequest;
	import flash.utils.ByteArray;
	import flash.geom.Rectangle;
	
	public class Spectre extends Sprite{
		
		private var _son:Sound;
		private var _canal:SoundChannel;
		private var _grapheSpectre:BitmapData;
		
		public function Spectre(sound:String){
			_grapheSpectre = new BitmapData(300,300,false,0x00000000);
			var bitmap:Bitmap = new Bitmap(_grapheSpectre);
			addChild(bitmap);
			//bitmap.x=20;
			//bitmap.y=20;
			
			
			_son = new Sound(new URLRequest(sound));
			_canal = _son.play();
		
			addEventListener(Event.ENTER_FRAME, onEnterFrame);		
		}
		
		private function onEnterFrame(evenement:Event):void{
			//Crée le tableau d'octets et le remplit de données
			var spectre:ByteArray = new ByteArray();
			SoundMixer.computeSpectrum(spectre);
			
			
			//Effacer le bitmap
			_grapheSpectre.fillRect(_grapheSpectre.rect,0x000000);
			
			_posx=75;
			_posy=50;
			
			//Canal gauche
			for(var i:int=0;i<0;i++){
				//_grapheSpectre.setPixel32(i,20+spectre.readFloat()*20,0xffffffff);
				
				
			}
				
			//Canal droit
			for(var j:int=1;j<512;j++){
				
				var my_readFloat = spectre.readFloat();
				
				
				//_grapheSpectre.drawRect(j,j,10,10)
				
				_grapheSpectre.lock()
				_grapheSpectre.setPixel32(j*1.5-1,10+my_readFloat*1,0xffffff);
				_grapheSpectre.setPixel32(j*2-2,20+my_readFloat*2,0xffffff);
				_grapheSpectre.setPixel32(j*3-3,30+my_readFloat*4,0xffffff);
				_grapheSpectre.setPixel32(j*4-4,40+my_readFloat*6,0xffffff);
				_grapheSpectre.setPixel32(j*5-5,50+my_readFloat*10,0xffffff);
				_grapheSpectre.setPixel32(j*6-6,60+my_readFloat*12,0xffffff);
				_grapheSpectre.setPixel32(j*7-7,70+my_readFloat*16,0xffffff);
				_grapheSpectre.setPixel32(j*8-8,80+my_readFloat*20,0xffffff);
				_grapheSpectre.setPixel32(j*9-9,90+my_readFloat*25,0xffffff);
				_grapheSpectre.setPixel32(j*10-10,100+my_readFloat*30,0xffffff);
				_grapheSpectre.setPixel32(j*11-11,110+my_readFloat*30,0xffffff);
				_grapheSpectre.setPixel32(j*12-12,120+my_readFloat*42,0xffffff);
				_grapheSpectre.setPixel32(j*13-13,130+my_readFloat*48,0xffffffff);
				_grapheSpectre.setPixel32(j*14-14,140+my_readFloat*56,0xffffffff);
				_grapheSpectre.setPixel32(j*15-15,150+my_readFloat*60,0xffffffff);
				_grapheSpectre.setPixel32(j*16-16,160+my_readFloat*65,0xffffffff);
				_grapheSpectre.setPixel32(j*17-17,170+my_readFloat*65,0xffffffff);
				_grapheSpectre.setPixel32(j*18-18,180+my_readFloat*75,0xffffffff);
				_grapheSpectre.setPixel32(j*19-19,190+my_readFloat*90,0xffffffff);
				_grapheSpectre.setPixel32(j*20-20,200+my_readFloat*100,0xffffffff);
				_grapheSpectre.setPixel32(j*21-21,210+my_readFloat*110,0xffffffff);
				_grapheSpectre.setPixel32(j*22-22,220+my_readFloat*120,0xffffffff);
				_grapheSpectre.setPixel32(j*23-23,230+my_readFloat*130,0xffffffff);
				_grapheSpectre.setPixel32(j*24-24,240+my_readFloat*140,0xffffffff);
				_grapheSpectre.setPixel32(j*25-25,250+my_readFloat*150,0xffffffff);
				_grapheSpectre.setPixel32(j*26-26,260+my_readFloat*160,0xffffffff);
				_grapheSpectre.setPixel32(j*27-27,270+my_readFloat*170,0xffffffff);
				_grapheSpectre.setPixel32(j*28-28,280+my_readFloat*180,0xffffffff);
				_grapheSpectre.setPixel32(j*29-29,290+my_readFloat*200,0xffffffff);
				_grapheSpectre.setPixel32(j*30-30,300+my_readFloat*210,0xffffffff);
				_grapheSpectre.setPixel32(j*31-31,310+my_readFloat*220,0xffffffff);
				_grapheSpectre.setPixel32(j*32-32,310+my_readFloat*230,0xffffffff);
				_grapheSpectre.setPixel32(j*33-33,310+my_readFloat*240,0xffffffff);
				_grapheSpectre.unlock()

				
				
				//val2=my_readFloat*500;
				//_rect2= new Rectangle(_posx+70-val2,_posy+(j*5),10,300);
				
				//_grapheSpectre.fillRect(_rect2,0x0c00ff);
				
			}
		}
	}
	
}